package sun.nio.fs;

import java.security.AccessController;
import sun.security.action.GetPropertyAction;
import java.nio.file.LinkOption;
import java.util.HashSet;
import java.util.Set;
import java.nio.charset.Charset;

class Util
{
    private static final Charset jnuEncoding;
    
    private Util() {
    }
    
    static Charset jnuEncoding() {
        return Util.jnuEncoding;
    }
    
    static byte[] toBytes(String s) {
        return s.getBytes(Util.jnuEncoding);
    }
    
    static String toString(byte[] bytes) {
        return new String(bytes, Util.jnuEncoding);
    }
    
    static String[] split(String s, char c) {
        int n = 0;
        for (int i = 0; i < s.length(); ++i) {
            if (s.charAt(i) == c) {
                ++n;
            }
        }
        String[] array = new String[n + 1];
        int n2 = 0;
        int n3 = 0;
        for (int j = 0; j < s.length(); ++j) {
            if (s.charAt(j) == c) {
                array[n2++] = s.substring(n3, j);
                n3 = j + 1;
            }
        }
        array[n2] = s.substring(n3, s.length());
        return array;
    }
    
    @SafeVarargs
    static <E> Set<E> newSet(E... array) {
        HashSet<Object> set = new HashSet();
        for (int length = array.length, i = 0; i < length; ++i) {
            set.add(array[i]);
        }
        return set;
    }
    
    @SafeVarargs
    static <E> Set<E> newSet(Set<E> c, E... array) {
        HashSet set = new HashSet(c);
        for (int length = array.length, i = 0; i < length; ++i) {
            set.add(array[i]);
        }
        return set;
    }
    
    static boolean followLinks(LinkOption... array) {
        boolean n = true;
        int length = array.length;
        int i = 0;
        while (i < length) {
            LinkOption linkOption = array[i];
            if (linkOption == LinkOption.NOFOLLOW_LINKS) {
                n = false;
                ++i;
            }
            else {
                if (linkOption == null) {
                    throw new NullPointerException();
                }
                throw new AssertionError("Should not get here");
            }
        }
        return n;
    }
    
    static {
        jnuEncoding = Charset.forName((String)AccessController.doPrivileged(new GetPropertyAction("sun.jnu.encoding")));
    }
}
